#include <iostream.h>
#include <conio.h>
#include "BinomialHeap.h"

template <class T>
NodB<T>::NodB(NodB<T> *n){
	this->parent = n->parent;
	this->child = n->child;
	this->sibling = n->sibling;
	this->degree = n->degree;
	this->key = n->key;

}

template <class T>
MergeHeap<T> *BinomialHeap<T>::makeHeap(){
	head = 0;
	return this;
}

template <class T>
BinomialHeap<T>::BinomialHeap(){
	head = 0;
}


template <class T>
void BinomialHeap<T>::binomialLink (NodB<T> *y, NodB<T> *z){
		
		y->parent = z;
		y->sibling = z->child;
		z->child = y;
		z->degree = z->degree + 1;
}

template <class T>
void BinomialHeap<T>::binomialHeapMerge (BinomialHeap<T> &H1){
		
		NodB<T> *temp, *temp1, *aux;
		if (head!=0){
			if (H1.head->degree < head->degree){
				temp = head;
				head = H1.head;
				temp1 = head->sibling;
				aux = head;
			}
			else {
				temp = head->sibling;
				temp1 = H1.head;
				aux = head;
			}
			
			while(temp!=0 && temp1!=0){
				if (temp1->degree < temp->degree){
					aux->sibling = temp1;
					aux = aux->sibling;
					temp1 = temp1->sibling; 
				}
				else {
					aux->sibling = temp;
					aux = aux->sibling;
					temp = temp->sibling;
				}
			}
			
			while(temp!=0){
				aux->sibling = temp;
				aux = aux->sibling;
				temp = temp->sibling;
			}
		
			while(temp1!=0){
				aux->sibling = temp1;
				aux = aux->sibling;
				temp1 = temp1->sibling;
			}
		}
		else 
			head = H1.head;
				
} 
	

template <class T>
void BinomialHeap<T>::hunion(MergeHeap<T> &H1){
		
		binomialHeapMerge((BinomialHeap&)H1);
		
		NodB<T> *prevx, *x, *nextx;
		prevx = 0;
		x = head;
		nextx = x->sibling;
		
		while (nextx!=0){
			if ((x->degree!= nextx->degree) || (nextx->sibling!=0 && nextx->sibling->degree == x->degree)){
				prevx = x;
				x = nextx;
			}
			else{
				if (x->key<=nextx->key){
					x->sibling = nextx->sibling;
					binomialLink(nextx,x);
				} 
				else {
					if(prevx == 0){
						head = nextx;
					}
					else prevx->sibling = nextx;
					binomialLink(x,nextx);
					x = nextx;
				}
			}
			nextx = x->sibling;
		}
		
}


template <class T>
void BinomialHeap<T>::hinsert(Nod<T> *x){
		
		BinomialHeap<T> H1;
	    H1.makeHeap();
		NodB<T> *x1 = (NodB<T>*)x;
		x1->parent = 0;
		x1->child = 0;
		x1->sibling = 0;
		x1->degree = 0;
		//H1.head = new Nod(x);
		H1.head = x1;
		hunion(H1); 
}


template <class T>
Nod<T>* BinomialHeap<T>::hminimum(){
		NodB<T> *y = 0;
		NodB<T> *x = head;
		T min = 100;
		
		while (x!= 0){
			if (x->key<min){
				min = x->key;
				y = x;
			}
			x = x->sibling;
		}
		return y;
}


template <class T>
Nod<T> *BinomialHeap<T>::hextractMinimum(){
		
		
		NodB<T> *prevx, *x, *nextx, *p=0;
		
		prevx = 0;
		x = head;
		nextx = x->sibling;
		NodB<T> *y = 0;
		
		T min = 100;
		BinomialHeap H1;
		H1.makeHeap();

				
		while (x!= 0){
			if (x->key<min){
				min = x->key;
				y = x;
				p = prevx;
										
			}
			prevx = x;
			x = x->sibling;
				
		}

		if (p!=0){
			p->sibling = y->sibling;
			H1.head = y;
			H1.head->sibling = 0;

			
		}	
		else{
			
			if(head->sibling!=0){
				head = head->sibling;
				H1.head = y;
				H1.head->sibling = 0;
				
			}
			else{ 
				head = 0;
				H1.head = y;
			}	
		}	
		
		
		NodB<T> *temp = H1.head;
		NodB<T> *prevz, *z, *nextz;
		prevz = 0;
		z = temp->child;
		nextz = z->sibling;
		z->parent = 0;
		
		if (z!=0){
			while (nextz!=0){
				z->sibling = prevz;
				z->parent = 0;
				prevz = z;
				z = nextz;
				nextz = nextz->sibling;
			}
			z->sibling = prevz;
			z->parent = 0;

			H1.head = z;
		
		}
		
		else{
			
			H1.head = 0;
		}
		
		
		hunion(H1);	

		return y;
			
}

template <class T>
void BinomialHeap<T>::hdecreaseKey (Nod<T> *x, T k){
		if (k > x->key)
			cout<<"Eroare noua cheie este mai mare decat cea curenta";
		

		NodB<T> *y,*z;
		T aux;	
		x->key = k;
		y = (NodB<T>*)x;
		z = y->parent;
		
		while (z != 0 && y->key < z->key){
			aux = y->key;
			y->key = z->key;
			z->key = aux;
			y = z;
			z = y->parent;
		
		}
		   	
	}
	

template <class T>
void BinomialHeap<T>::hdelete (Nod<T> *x){
		hdecreaseKey (x,-1);
		hextractMinimum();
	} 




