#ifndef BINOMIALHEAP_H
#define BINOMIALHEAP_H
#include "BinomialHeapAbstract.h"

template<class T> class BinomialHeap;

template<class T>class NodB : public Nod<T>
{	
      friend class BinomialHeap<T>; 
   private:
      NodB<T> *parent;
      NodB<T> *child;
      NodB<T> *sibling;
      int degree;
   public:
      NodB<T>(T k) {parent = 0; child = 0; sibling = 0; degree =0; key = k; }
      NodB<T>(NodB<T> *n);
     
};



template<class T> class BinomialHeap : public MergeHeap<T>{
	private:
   		NodB<T> *head;
    public:
	    BinomialHeap();
        virtual MergeHeap<T> *makeHeap();  
        virtual void hunion (MergeHeap<T> &H1);
        virtual void hinsert (Nod<T> *x);
        virtual Nod<T> *hminimum ();
        virtual Nod<T> *hextractMinimum ();
	    virtual void hdecreaseKey(Nod<T> *x,T k);
		virtual void hdelete(Nod<T> *x);
	protected:
        void binomialLink(NodB<T> *y,NodB<T> *z);
        void binomialHeapMerge(BinomialHeap<T> &h2);
};

#endif
